package com.ims.eval.service.impl;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ims.common.utils.StringUtils;
import com.ims.eval.dao.EvaluationDeptBusinessContentMapper;
import com.ims.eval.entity.EvaluationDeptBusinessContent;
import com.ims.eval.entity.OrganizationStructure;
import com.ims.eval.service.IEvaluationDeptBusinessContentService;
import com.ims.eval.service.IOrganizationStructureService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author hlf
 * @date 2023/5/6 10:40
 * 文件说明：
 */
@Service
public class EvaluationDeptBusinessContentServiceImpl extends ServiceImpl<EvaluationDeptBusinessContentMapper, EvaluationDeptBusinessContent> implements IEvaluationDeptBusinessContentService {

	@Autowired
	private IOrganizationStructureService organizationStructureService;

	@Override
	public List<EvaluationDeptBusinessContent> detailsList(String businessPlanId, String deptId) {
		if ("23031009".equals(deptId)) {
			deptId = "";
		}
		return baseMapper.detailsList(businessPlanId, deptId);
	}

	@Override
	public boolean removeByBusinessPlanId(String businessPlanId) {
		return baseMapper.removeByBusinessPlanId(businessPlanId);
	}

	@Override
	public boolean saveOrUpdateBatch(List<EvaluationDeptBusinessContent> evaluationDeptBusinessContentList) {
		boolean b = false;
		for (EvaluationDeptBusinessContent evaluationDeptBusinessContent : evaluationDeptBusinessContentList) {
			if (StringUtils.isEmpty(evaluationDeptBusinessContent.getId())) {
				List<OrganizationStructure> organizationStructureList = organizationStructureService.getTree("23031001", 1, "140");
				OrganizationStructure organizationStructure = organizationStructureList.stream().filter(item -> item.getId().equals(evaluationDeptBusinessContent.getDeptId())).findFirst().orElse(null);
				if (ObjectUtil.isNotNull(organizationStructure)){
					evaluationDeptBusinessContent.setDeptName(organizationStructure.getName());
					evaluationDeptBusinessContent.setCreateTime(DateUtil.date());
					b = super.save(evaluationDeptBusinessContent);
				}
			} else {
				b = super.updateById(evaluationDeptBusinessContent);
			}
		}
		return b;
	}

	@Override
	public List<EvaluationDeptBusinessContent> selectEvaluationDeptBusinessContentListByBusinessPlanId(String businessPlanId, String deptId) {
		return baseMapper.selectEvaluationDeptBusinessContentListByBusinessPlanId(businessPlanId, deptId);
	}
}
